Summary: Configure GNOME to work with AFS home directories
Name: SL_startgnome_afs
Version: 1.1
Release: 1
Copyright: GPL
Group: SL
Vendor: Scientific Linux
Packager: Jan Iven <jan.iven@cern.ch>
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: /usr/bin/gnome-session /bin/rm /bin/mv
BuildArch: noarch

Source0: GNOME-on-afs.session
Source1: gnome-afs-profile.sh
Source2: gnome-afs-profile.csh

%description

GNOME assumes that user processes may be left running after a session
has been closed. This is not a good idea on AFS, since these processes
will not be able to touch the user's home directory anymore, so lock
files stay in place etc...

This RPM modifies the session launched via gdm to remove old lock
files before starting (when most likely we have credentials) and after
shutting down (when we may not have credentials), and stops a number
of services launched on the user's behalf.

For AFS users, it also tells GNOME to create future lock files in a
local temporary directory. This no longer prevents multiple instances
of GNOME from running in parallel (and so in theory risks gconf
corruption), but prevents AFS corruptions.


%install
mkdir -p $RPM_BUILD_ROOT{/usr/bin/,/etc/profile.d/} 
install -m 755 %{SOURCE0} $RPM_BUILD_ROOT/usr/bin/gnome-session.with-afs
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT/etc/profile.d/
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/profile.d/

%files
%defattr(-,root,root)
/usr/bin/gnome-session.with-afs
/etc/profile.d/gnome-afs-profile.sh
/etc/profile.d/gnome-afs-profile.csh

%post
if [ -e /usr/bin/gnome-session -a ! -e /usr/bin/gnome-session.bin ]; then
    mv /usr/bin/gnome-session /usr/bin/gnome-session.bin
    ln -s gnome-session.with-afs /usr/bin/gnome-session
fi

%postun
if [ "$1" = "0" ] ; then
  if [ -L /usr/bin/gnome-session -a -e /usr/bin/gnome-session.bin ]; then
	rm /usr/bin/gnome-session
	mv /usr/bin/gnome-session.bin  /usr/bin/gnome-session
  fi
fi

%triggerin -- switchdesk
if [ -f /usr/bin/gnome-session -a ! -L /usr/bin/gnome-session ]; then
    if [ -e /usr/bin/gnome-session.bin ]; then
	rm /usr/bin/gnome-session.bin
    fi
    if [ -e /usr/bin/gnome-session-on-afs ]; then
	mv /usr/bin/gnome-session /usr/bin/gnome-session.bin
	ln -s gnome-session.with-afs /usr/bin/gnome-session
    fi
fi


%changelog
* Tue Jun  7 2005 Jan Iven <jan.iven@cern.ch>
- move local lock setting into /etc/profile.d so that mixed KDE/GNOME
  sessions use it as well

* Tue Jun 29 2004  Jan Iven <jan.iven@cern.ch>
- initial version
